/* */
/******************************************************************/
/*** Set all Acesss authorizations to the AMU-Database-Programs ***/
/******************************************************************/

startdbm
dbm start using database abba


rcy = rxfuncadd('SQLDBS' , 'SQLAR','SQLDBS' );
rcy = rxfuncadd('SQLEXEC', 'SQLAR','SQLEXEC');


  /******************************************************************/
  /*** Do the change to ArcBack                                   ***/
  /******************************************************************/
  prep_string = "SELECT CREATOR FROM SYSIBM.SYSPLAN WHERE NAME = 'ARCBACK'";
  call sqlexec 'DECLARE c1 CURSOR FOR s1';
  call sqldbs 'START USING DATABASE ABBA';

  if (SQLCA.SQLCODE <> 0 & SQLCA.SQLCODE <> -1098) then
    /*** If the Database could notbe started, stop the procedure ***/
    say 'Start DB Error: SQLCODE = ' SQLCA.SQLCODE;
  else do
    /*** if the database could be started, open the cursor ***/
    call sqlexec 'PREPARE s1 FROM :prep_string';
    if (SQLCA.SQLCODE <> 0) then
      say 'Error preparing statement: SQLCODE = ' SQLCA.SQLCODE;
    else do
      call sqlexec 'OPEN c1';

    /*** Fetch one Record */
    call sqlexec 'FETCH c1 INTO :creator';
    say 'creator of ARCBACK is ' creator;
    grantstring = 'GRANT EXECUTE,BIND ON PROGRAM '||creator||'.ARCBACK TO PUBLIC';
    say grantstring
    call sqlexec 'EXECUTE IMMEDIATE :grantstring';
    if (SQLCA.SQLCODE <> 0) then
      say 'Error preparing statement: SQLCODE = ' SQLCA.SQLCODE;
    call sqlexec 'CLOSE c1';
  end

  call sqldbs 'STOP USING DATABASE';
  if (SQLCA.SQLCODE <> 0) then
    say 'Start DB Error: SQLCODE = ' SQLCA.SQLCODE;
  end


  /******************************************************************/
  /*** Do the change to ArcSQLeN                                  ***/
  /******************************************************************/
  prep_string = "SELECT CREATOR FROM SYSIBM.SYSPLAN WHERE NAME = 'ARCSQLEN'";
  call sqlexec 'DECLARE c1 CURSOR FOR s1';
  call sqldbs 'START USING DATABASE ABBA';

  if (SQLCA.SQLCODE <> 0 & SQLCA.SQLCODE <> -1098) then
    /*** If the Database could notbe started, stop the procedure ***/
    say 'Start DB Error: SQLCODE = ' SQLCA.SQLCODE;
  else do
    /*** if the database could be started, open the cursor ***/
    call sqlexec 'PREPARE s1 FROM :prep_string';
    if (SQLCA.SQLCODE <> 0) then
      say 'Error preparing statement: SQLCODE = ' SQLCA.SQLCODE;
    else do
      call sqlexec 'OPEN c1';

    /*** Fetch one Record */
    call sqlexec 'FETCH c1 INTO :creator';
    say 'creator of ARCSQLEN is ' creator;
    grantstring = 'GRANT EXECUTE,BIND ON PROGRAM '||creator||'.ARCSQLEN TO PUBLIC';
    say grantstring
    call sqlexec 'EXECUTE IMMEDIATE :grantstring';
    if (SQLCA.SQLCODE <> 0) then
      say 'Error preparing statement: SQLCODE = ' SQLCA.SQLCODE;
    call sqlexec 'CLOSE c1';
  end

  call sqldbs 'STOP USING DATABASE';
  if (SQLCA.SQLCODE <> 0) then
    say 'Start DB Error: SQLCODE = ' SQLCA.SQLCODE;
  end


  /******************************************************************/
  /*** Do the change to ArcSQLe                                   ***/
  /******************************************************************/
  prep_string = "SELECT CREATOR FROM SYSIBM.SYSPLAN WHERE NAME = 'ARCSQLE'";
  call sqlexec 'DECLARE c1 CURSOR FOR s1';
  call sqldbs 'START USING DATABASE ABBA';

  if (SQLCA.SQLCODE <> 0 & SQLCA.SQLCODE <> -1098) then
    /*** If the Database could notbe started, stop the procedure ***/
    say 'Start DB Error: SQLCODE = ' SQLCA.SQLCODE;
  else do
    /*** if the database could be started, open the cursor ***/
    call sqlexec 'PREPARE s1 FROM :prep_string';
    if (SQLCA.SQLCODE <> 0) then
      say 'Error preparing statement: SQLCODE = ' SQLCA.SQLCODE;
    else do
      call sqlexec 'OPEN c1';

    /*** Fetch one Record */
    call sqlexec 'FETCH c1 INTO :creator';
    say 'creator of ARCSQLE is ' creator;
    grantstring = 'GRANT EXECUTE,BIND ON PROGRAM '||creator||'.ARCSQLE TO PUBLIC';
    say grantstring
    call sqlexec 'EXECUTE IMMEDIATE :grantstring';
    if (SQLCA.SQLCODE <> 0) then
      say 'Error preparing statement: SQLCODE = ' SQLCA.SQLCODE;
    call sqlexec 'CLOSE c1';
  end

  call sqldbs 'STOP USING DATABASE';
  if (SQLCA.SQLCODE <> 0) then
    say 'Start DB Error: SQLCODE = ' SQLCA.SQLCODE;
  end

  /******************************************************************/
  /*** Do the change to ARCBSQL                                   ***/
  /******************************************************************/
  prep_string = "SELECT CREATOR FROM SYSIBM.SYSPLAN WHERE NAME = 'ARCBSQL'";
  call sqlexec 'DECLARE c1 CURSOR FOR s1';
  call sqldbs 'START USING DATABASE ABBA';

  if (SQLCA.SQLCODE <> 0 & SQLCA.SQLCODE <> -1098) then
    /*** If the Database could notbe started, stop the procedure ***/
    say 'Start DB Error: SQLCODE = ' SQLCA.SQLCODE;
  else do
    /*** if the database could be started, open the cursor ***/
    call sqlexec 'PREPARE s1 FROM :prep_string';
    if (SQLCA.SQLCODE <> 0) then
      say 'Error preparing statement: SQLCODE = ' SQLCA.SQLCODE;
    else do
      call sqlexec 'OPEN c1';

    /*** Fetch one Record */
    call sqlexec 'FETCH c1 INTO :creator';
    say 'creator of ARCBSQL is ' creator;
    grantstring = 'GRANT EXECUTE,BIND ON PROGRAM '||creator||'.ARCBSQL TO PUBLIC';
    say grantstring
    call sqlexec 'EXECUTE IMMEDIATE :grantstring';
    if (SQLCA.SQLCODE <> 0) then
      say 'Error preparing statement: SQLCODE = ' SQLCA.SQLCODE;
    call sqlexec 'CLOSE c1';
  end

  call sqldbs 'STOP USING DATABASE';
  if (SQLCA.SQLCODE <> 0) then
    say 'Start DB Error: SQLCODE = ' SQLCA.SQLCODE;
  end
